# Urduistics: A Python NLP library for Urdu and Roman Urdu language

![](https://github.com/AIMLAB-Fast/URDUISTICS_RESOURCES/blob/main/gifs/aim_urduistics_normalization.gif)

<!--
[![image](https://img.shields.io/pypi/pyversions/urduhack.svg)](https://pypi.org/project/urduhack/)[![image](https://img.shields.io/pypi/v/urduhack.svg)](https://pypi.org/project/urduhack/)
[![Azure DevOps builds](https://img.shields.io/azure-devops/build/urduhack/urduhack/2?logo=azure-pipelines)](https://dev.azure.com/Urduhack/Urduhack/_build?definitionId=2)
[![Azure DevOps tests](https://img.shields.io/azure-devops/tests/urduhack/urduhack/2?logo=azure-pipelines)](https://dev.azure.com/Urduhack/Urduhack/_build?definitionId=2)
[![Build Status](https://img.shields.io/travis/urduhack/urduhack?label=linux%20build&logo=travis)](https://travis-ci.org/urduhack/urduhack)
[![CodeFactor](https://www.codefactor.io/repository/github/urduhack/urduhack/badge)](https://www.codefactor.io/repository/github/urduhack/urduhack)
[![codecov](https://codecov.io/gh/urduhack/urduhack/branch/master/graph/badge.svg)](https://codecov.io/gh/urduhack/urduhack)
[![image](https://img.shields.io/github/contributors/urduhack/urduhack.svg)](https://github.com/urduhack/urduhack/graphs/contributors)
[![Downloads](https://pepy.tech/badge/urduhack)](https://pepy.tech/project/urduhack)
[![Gitter](https://badges.gitter.im/urduhack/urduhack.svg)](https://gitter.im/urduhack)
[![License: MIT](https://img.shields.io/badge/license-MIT-blue.svg)](https://github.com/urduhack/urduhack/blob/master/LICENSE)
-->

Urduistics is an NLP for libary for the processing of Urdu language, extending to Roman Urdu. 

For more information, you can contact @ https://github.com/mutharibayub

Objectives:
--------

- **Academic users** Bypass primary coding steps to directly work on experimenation and execution.
- **NLP beginners**  Learn how to create an NLP project.
- **NLP developers**  Create an fucntional application using Urduistics. 

Key Features:
-------------------
| Feature            |              Urdu | Roman Urdu                                 |
| ---------------    | ------------------|------------------------------------------- |
|Normalization       |               YES |                                        YES |
|Prepocessing        |               YES |                                         NO |
|Tokenization        |               YES |                                         NO |

 Models:
-------------------
- [x] Pos tagger
- [x] NER tagger
- [x] Lemmatizer
- [ ] Sentiment Analysis
- [ ] Image to text
- [ ] Question Answering System


Installation:
---------------
Urduistics officially supports Python 3.11.

Install with pip:
```
$ pip install urduistics
```

Usage
-----
<!--
```python
import urduhack

# Downloading models
urduhack.download()

nlp = urduhack.Pipeline()
text = ""
doc = nlp(text)

for sentence in doc.sentences:
    print(sentence.text)
    for word in sentence.words:
        print(f"{word.text}\t{word.pos}")

    for token in sentence.tokens:
        print(f"{token.text}\t{token.ner}")
```
-->

Documentation
----------------
Complete documentation is available at <!-- # <https://urduhack.readthedocs.io/> -->

| Documentation   |                                                                |
| --------------- | -------------------------------------------------------------- |
| [Installation]  | How to install Urduistics and download models                    |
| [Quickstart]    | Click here to get started with Urduistics!         |
| [API Reference] | To be added.                     |
<!--
[Installation]: https://urduhack.readthedocs.io/en/stable/installation.html
[Quickstart]: https://urduhack.readthedocs.io/en/stable/quickstart/index.html
[Api reference]: https://urduhack.readthedocs.io/en/stable/reference/index.html
[Contribute]: https://github.com/urduhack/urduhack/blob/master/CONTRIBUTING.md
-->
 Contributors
----------------
This project would not have been possible without the hardwork of our contributors. We thank everyone who worked on to bring Urduistics to life!

Copyright and license
------------------------
Code released under the [MIT License](ttps://github.com/urduhack/urduhack/blob/master/LICENSE).
