romanurdu_stopwords = frozenset([
    "ahi", "ayi", "hey", "hai", "mein", "ki", "tha", "koi", "ko", "sy", "woh",
    "bhi", "aur", "woh", "yeh", "raha", "hota", "ho", "gah", "ka", "le", "lye",
    "kr", "kar", "lye", "liye", "hotay", "waisay", "gya", "gaya", "kuch", "abh",
    "thy", "thay", "hoon", "hain", "han", "to", "is", "hi", "joh", "kya", "thi",
    "se", "pe", "phr", "wala", "waisay", "us", "na", "ny", "hun", "rha", "raha",
    "ja", "rahay", "abi", "uski", "ne", "haan", "acha", "nai", "sent", "photo",
    "you", "kafi", "gahi", "rhy", "kuch", "jata", "aye", "yah", "dono", "hoa",
    "aese", "de", "wohi", "jati", "jb", "krta", "lage", "rahi", "hui", "karna",
    "krna", "ghi", "howa", "yehi", "jana", "jye", "chal", "mil", "tu", "hum", "par",
    "hay", "kis", "sab", "gaye", "dain", "krny", "tou", "kay"
])

def remove_stopwords(text: str) -> str:
    """
          Returns a string after removing roman-urdu stopwords from it.
                Parameters:
                      text (str): String that needs to be processed.
                Returns:
                      string (string): String from which roman-urdu stopwords have been removed.

          >>> remove_stopwords("Mein lahore ki taraf jana chahta hoon")
          'lahore taraf chahta'

          >>> remove_stopwords("Ahj mein bohat khush hoon")
          'Ahj bohat khush'

          >>> remove_stopwords("Humein aadat par gahi hey barish kay mousam ki")
          'Humein aadat barish mousam'
    """

    string = ''
    for x in text.split():
        if x.lower() not in romanurdu_stopwords:
            string += x + ' '

    string = string.rstrip()
    return string

