from urduistics.urdu import sent_tokenize, word_tokenize
from urduistics.utils import load_resource

def lemmatizer(text:str) -> str:
    LEMMATIZER_DICT = load_resource('URDU_LEMMATIZER_DICT',"json")
    sentences = sent_tokenize(text)
    words = [[]*len(sentences)]
    output = []
    for index, sentence in enumerate(sentences):
        words[index] = word_tokenize(sentence)
        for count in range(len(words[index])):
            if words[index][count] in LEMMATIZER_DICT:
                words[index][count] = LEMMATIZER_DICT[words[index][count]]
            output.append({"sent":index,"word":words[index][count]})
    return output