
from urduistics.utils import load_resource

dataset = load_resource("URDU_STEMMER_DATASET")
STOP_WORD_LIST = frozenset(['بڑی', 'اپنے', 'تھی', 'رہی', 'اگرچہ', 'کسی', 'وار', 'رکھتا', 'ارب', 'چاہے', 'کریں', 'اور', 'گھنٹوں', 'مرے', 'یہی', 'ضرور', 'قبل', 'لگتی', 'لائی', 'مسز', 'رکھتی', 'ہوتیں', 'وہی', 'سبھی', 'آدھا', 'جا', 'چکی', 'نہ', 'وہ', 'جنہوں', 'اپنی', 'لو', 'لوجی', 'رکھا', 'آئی', 'اپنےآپ', 'حضرت', 'لیتی', 'جی', 'واقعی', 'صاحب', 'اہاہا', 'کرے', 'رکھے', 'جس', 'جاتی', 'کرتے', 'کو', 'ہائیں', 'گنا', 'ماسوا', 'پہلی', 'پونا', 'کبھی', 'تری', 'سے', 'ورنہ', 'جائیں', 'نا', 'لگے', 'انہیں', 'لے', 'ارے', 'رہیں', 'پیر', 'کیسا', 'بھر', 'جبکہ', 'انہی', 'دیکھو', 'اسے', 'ہونی', 'والی', 'بخیر', 'افوہ', 'لوگوں', 'ساتھ', 'پہلے', 'وہیں', 'کر', 'کچھ', 'باہر', 'لگا', 'کہ', 'ڈالے', 'جائے', 'تھیں', 'دیتے', 'تب', 'کرنا', 'جاتا', 'کہی', 'تک', 'فی', 'گھنٹا', 'لاتا', 'دینے', 'یک', 'محترم', 'اوپر', 'تلک', 'رکھنا', 'جانے', 'ہوا', 'کرنے', 'دوسرا', 'آنسہ', 'میروں', 'ابے', 'گرما', 'ایسی', 'ہم', 'آنے', 'چاہتے', 'کونسے', 'منٹوں', 'مسٹر', 'لیکن', 'اپنا', 'کرم', 'تمہیں', 'گی', 'پھر', 'مل', 'لگیں', 'دیتا', 'سراسر', 'ہمارے', 'باوجود', 'گئے', 'اکثر', 'صاحبہ', 'دائیں', 'ہوتا', 'اپنوں', 'جنہیں', 'انہوں', 'پہ', 'لئے', 'آئیں', 'سمیت', 'تجھ', 'سہ', 'جناب', 'ہمی', 'کئے', 'گیا', 'نزدیک', 'لیا', 'چونکہ', 'آتے', 'واہ', 'ڈالنا', 'فقط', 'تیرا', 'ابھی', 'اب', 'ولے', 'رہنے', 'حالانکہ', 'اگر', 'لاتے', 'پیچھے', 'یات', 'مت', 'تم', 'دوں', 'ویسا', 'تمہاری', 'کیونکر', 'کسے', 'محض', 'پونی', 'بشرطیکہ', 'ویسے', 'مجھے', 'ایک', 'گھنٹے', 'دیتی', 'اوہو', 'درمیان', 'جدھر', 'اسکے', 'فلاں', 'پہلا', 'کا', 'جانی', 'رکھنی', 'رہتی', 'میرا', 'مری', 'سب', 'جسے', 'چناچہ', 'لانی', 'جہاں', 'خود', 'مرا', 'واسطے', 'عین', 'یہ', 'بہتر', 'آمدید', 'رکھو', 'طور', 'محترمہ', 'آتا', 'کہیں', 'اربویں', 'دینا', 'بناؤ', 'ہونا', 'ہوتے', 'علاوہ', 'اندر', 'چوگنی', 'لاتی', 'خواہ', 'تمہاروں', 'میں', 'آہا', 'جاؤ', 'جیسا', 'مگھر', 'والوں', 'ہر', 'کونسا', 'رہے', 'چلو', 'تجھے', 'کن', 'کنہیں', 'ہمارا', 'آدھی', 'کاش', 'بجے', 'دگنا', 'گویا', 'سامنے', 'لائے', 'اسکی', 'شکریہ', 'ہرگز', 'ایسا', 'لانے', 'بن', 'ہونے', 'بالکل', 'قطا', 'اس', 'ہیں', 'بغیر', 'کی', 'تھا', 'البتہ', 'بارے', 'پس', 'گو', 'آ', 'بعد', 'وگرنہ', 'جو', 'نو', 'جاتے', 'بلکہ', 'ایسے', 'دی', 'پہر', 'ہوں', 'لانا', 'بند', 'پون', 'لیتا', 'مزید', 'و', 'کے', 'نیچے', 'تمہارے', 'تھے', 'مطابق', 'کیونکہ', 'چاہیئے', 'گا', 'منٹ', 'گئی', 'اگست', 'ویں', 'لیں', 'یہاں', 'ترا', 'بہت', 'وجہ', 'بائیں', 'حالاں', 'آدھ', 'دوران', 'کیا', 'جب', 'تہائی', 'ہماری', 'آداب', 'پر', 'بھریں', 'اوئے', 'مگر', 'رہتے', 'آگے', 'بعض', 'لیے', 'کہے', 'اف', 'سوا', 'حصہ', 'سکا', 'وعلیکم', 'تمام', 'رکھنے', 'صرف', 'آیا', 'چند', 'سی', 'کہاں', 'گرمی', 'تیری', 'کیوں', 'رکھی', 'ان', 'وہاں', 'تجھی', 'میری', 'سکتے', 'ہوبہو', 'ہوئیں', 'جیسی', 'بج', 'تو', 'ساڑھے', 'ہائے', 'مس', 'خالی', 'تمہارا', 'چلے', 'آہ', 'تاہم', 'آس', 'لگ', 'کدھر', 'سہی', 'رہ', 'نیز', 'اپ', 'جن', 'اسی', 'دیا', 'مرحبا', 'الف', 'یا', 'تیرے', 'اتوار', 'آدھے', 'جیسوں', 'رہنی', 'آتی', 'ہاں', 'دیر', 'ڈالنے', 'دے', 'تاکہ', 'ڈالنی', 'جیسے', 'شاید', 'چکیں', 'ذریعے', 'سکتا', 'محترمی', 'ہوئے', 'نہیں', 'والے', 'ہمیں', 'سوائے', 'ہوئی', 'آپ', 'رہنا', 'یہیں', 'دینی', 'انکے', 'کیسے', 'لگتا', 'دیئے', 'ہی', 'کہا', 'نما', 'لایا', 'ہوتی', 'دیں', 'میرے', 'رہو', 'وغیرہ', 'دوسری', 'بیگم', 'آئے', 'بھی', 'کل', 'ہونگے', 'بنا', 'کوئی', 'کیے', 'دیے', 'طرف', 'آنی', 'ہو', 'انکا', 'بار', 'اسکا', 'رہتا', 'چاہئے', 'کرتی', 'لگی', 'پونے', 'دکھائیں', 'دریں', 'لیتے', 'مجھی', 'ہے', 'چکے', 'رکھتے', 'چلا', 'کرتا', 'نے', 'خاطر', 'طرح', 'انکی', 'لہذا', 'تین', 'رہا', 'ہزار', 'کہہ', 'پلیز', 'آنا', 'کرو', 'کس', 'پاس', 'خوب', 'چلیں', 'ہیلو', 'ہرچند', 'پایا', 'لی', 'مکرمی', 'کب', 'کم', 'دوسروں', 'کون', 'مجھ', 'مہربانی', 'یعنی', 'دو', 'والا'])

#====================================================
def isPreException(word): 
    if word in dataset["PrGEL"]:
        return True
    return False
#====================================================

def isPoException(word): 
    if word in dataset["PoGEL"]:
        return True
    return False
#====================================================
def removePrefix(word): 
    newWord = "" 
    for w in dataset["Prefixes"]: 
        if(word.find(w,0,len(w))==0): 
            newWord = word[len(w):len(word)]
            return newWord
    return word 

#====================================================
def removePostfix(word):
    newWord = ""
    P = "" 
    for w in dataset["Postfixes"]: 
        if word.find(w,len(word)-len(w),len(word)) != -1: 
            if(len(w) > len(P)): 
                P = ""
                P = w 
    if P != "": 
        newWord = word[0:len(word)-len(P)]  
        return newWord    
    return word 
#====================================================
def ACL(word):  
    key = []
    ACL = []
    text = dataset["CAL"]

    for i in range(0,5): 
        allWords = []
        s = ""
        for c in text[i]: 
            if c != ":":  
                s+= c 
            else:
                allWords.append(s)
                s = "" 

        ACL.append(allWords)
        key.append(s)
    for i in range(0,5): 
        for w in ACL[i]:
            if w == word:
                word = word + key[i]
                break   
    return word 
#==================================================== 

def runner(w):
    word = w 
    if len(word) <= 3:
        return word
    else: 
        if(isPreException(word)== False): 
            word = removePrefix(word)

        if(isPoException(word)== False): 
            word = removePostfix(word)

        word = ACL(word)
        return(word)

def stemmer(text):
    tokens = text.split() 
    
    words = []
    for word in tokens: 
        if word not in STOP_WORD_LIST: 
            words.append(word)

    final_list = []
    for w in words: 
        final_list.append(runner(w))

    return(final_list)
