import urllib.request
import zipfile
import os
from tqdm import tqdm


class DownloadProgressBar(tqdm):
    def update_to(self, b=1, bsize=1, tsize=None):
        if tsize is not None:
            self.total = tsize
        self.update(b * bsize - self.n)

def download_url(url, output_folder):
    filename = url.split('/')[-1]
    output_path = os.path.join(output_folder,filename)
    with DownloadProgressBar(unit='B', unit_scale=True,
                             miniters=1, desc=filename) as t:
        urllib.request.urlretrieve(url, filename=output_path, reporthook=t.update_to)
    if filename.rstrip('.zip') != filename:
        with zipfile.ZipFile(output_path,"r") as zip_ref:
            zip_ref.extractall(output_folder)
        os.remove(output_path)